﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Management.Automation;
using System.ComponentModel;

namespace Prelude.Commands
{
    [Cmdlet("Get", "FileLockingProcess")]
    public class GetFileLockingProcess : Cmdlet
    {
        FileInfo[] _files = new FileInfo[0];

        [Parameter(Mandatory = true, Position = 0, ValueFromPipeline = true, ValueFromPipelineByPropertyName = true)]
        public object[] File
        {
            get
            {
                return this._files;
            }
            set
            {
                List<FileInfo> l = new List<FileInfo>();
                Action<object[]> act = null;
                act = delegate(object[] objs)
                    {
                        foreach (object _o in objs)
                        {
                            object o = (_o is PSObject) ? ((PSObject)_o).BaseObject : _o;
                            if (o is FileInfo)
                            {
                                l.Add(o as FileInfo);
                                continue;
                            }
                            if (o is string)
                            {
                                FileInfo file = new FileInfo(o as string);
                                if (file.Exists)
                                {
                                    l.Add(file);
                                    continue;
                                }
                            }
                            if (o is object[])
                            {
                                act(o as object[]);
                            }
                        }
                    };
                act(value);
                _files = l.ToArray();

            }
        }

        protected override void ProcessRecord()
        {
            try
            {
                this.WriteObject(Prelude.Internal.RestartMgr.GetProcessesByWhichFilesInUse(_files), true);
            }
            catch (Win32Exception ex)
            {
                string filelist = string.Join("/",
                    Array.ConvertAll<FileInfo, string>(_files, delegate(FileInfo f) { return f.Name; }));

                WriteError(new ErrorRecord(
                           new Exception("An error occurred. Files: " + filelist, ex),
                           "Win32Error",
                           ErrorCategory.InvalidOperation,
                           _files));
            }

        }
    }
}

